// GENERATED CODE - DO NOT EDIT

// Copyright 2019 The Flutter team. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

import 'dart:ui' as ui;
import 'package:flutter/material.dart';
import '../google_fonts_base.dart';
import '../google_fonts_descriptor.dart';
import '../google_fonts_variant.dart';

/// Methods for fonts starting with 'Q'.
class PartQ {
  /// Applies the Qahiri font family from Google Fonts to the
  /// given [textStyle].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Qahiri
  static TextStyle qahiri({
    TextStyle? textStyle,
    Color? color,
    Color? backgroundColor,
    double? fontSize,
    FontWeight? fontWeight,
    FontStyle? fontStyle,
    double? letterSpacing,
    double? wordSpacing,
    TextBaseline? textBaseline,
    double? height,
    Locale? locale,
    Paint? foreground,
    Paint? background,
    List<ui.Shadow>? shadows,
    List<ui.FontFeature>? fontFeatures,
    TextDecoration? decoration,
    Color? decorationColor,
    TextDecorationStyle? decorationStyle,
    double? decorationThickness,
  }) {
    final fonts = <GoogleFontsVariant, GoogleFontsFile>{
      const GoogleFontsVariant(
        fontWeight: FontWeight.w400,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        '4f66733e61d4cb2734ba69d9495034c0f98175bba5a7ef95d399e64d9349b70f',
        19704,
      ),
    };

    return googleFontsTextStyle(
      textStyle: textStyle,
      fontFamily: 'Qahiri',
      color: color,
      backgroundColor: backgroundColor,
      fontSize: fontSize,
      fontWeight: fontWeight,
      fontStyle: fontStyle,
      letterSpacing: letterSpacing,
      wordSpacing: wordSpacing,
      textBaseline: textBaseline,
      height: height,
      locale: locale,
      foreground: foreground,
      background: background,
      shadows: shadows,
      fontFeatures: fontFeatures,
      decoration: decoration,
      decorationColor: decorationColor,
      decorationStyle: decorationStyle,
      decorationThickness: decorationThickness,
      fonts: fonts,
    );
  }

  /// Applies the Qahiri font family from Google Fonts to every
  /// [TextStyle] in the given [textTheme].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Qahiri
  static TextTheme qahiriTextTheme([TextTheme? textTheme]) {
    textTheme ??= ThemeData.light().textTheme;
    return TextTheme(
      displayLarge: qahiri(textStyle: textTheme.displayLarge),
      displayMedium: qahiri(textStyle: textTheme.displayMedium),
      displaySmall: qahiri(textStyle: textTheme.displaySmall),
      headlineLarge: qahiri(textStyle: textTheme.headlineLarge),
      headlineMedium: qahiri(textStyle: textTheme.headlineMedium),
      headlineSmall: qahiri(textStyle: textTheme.headlineSmall),
      titleLarge: qahiri(textStyle: textTheme.titleLarge),
      titleMedium: qahiri(textStyle: textTheme.titleMedium),
      titleSmall: qahiri(textStyle: textTheme.titleSmall),
      bodyLarge: qahiri(textStyle: textTheme.bodyLarge),
      bodyMedium: qahiri(textStyle: textTheme.bodyMedium),
      bodySmall: qahiri(textStyle: textTheme.bodySmall),
      labelLarge: qahiri(textStyle: textTheme.labelLarge),
      labelMedium: qahiri(textStyle: textTheme.labelMedium),
      labelSmall: qahiri(textStyle: textTheme.labelSmall),
    );
  }

  /// Applies the Quando font family from Google Fonts to the
  /// given [textStyle].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Quando
  static TextStyle quando({
    TextStyle? textStyle,
    Color? color,
    Color? backgroundColor,
    double? fontSize,
    FontWeight? fontWeight,
    FontStyle? fontStyle,
    double? letterSpacing,
    double? wordSpacing,
    TextBaseline? textBaseline,
    double? height,
    Locale? locale,
    Paint? foreground,
    Paint? background,
    List<ui.Shadow>? shadows,
    List<ui.FontFeature>? fontFeatures,
    TextDecoration? decoration,
    Color? decorationColor,
    TextDecorationStyle? decorationStyle,
    double? decorationThickness,
  }) {
    final fonts = <GoogleFontsVariant, GoogleFontsFile>{
      const GoogleFontsVariant(
        fontWeight: FontWeight.w400,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        '54167b158eb5f0afb7f16880da0adb3ebd589f4ee12f7bb62ed4f628043c887a',
        46320,
      ),
    };

    return googleFontsTextStyle(
      textStyle: textStyle,
      fontFamily: 'Quando',
      color: color,
      backgroundColor: backgroundColor,
      fontSize: fontSize,
      fontWeight: fontWeight,
      fontStyle: fontStyle,
      letterSpacing: letterSpacing,
      wordSpacing: wordSpacing,
      textBaseline: textBaseline,
      height: height,
      locale: locale,
      foreground: foreground,
      background: background,
      shadows: shadows,
      fontFeatures: fontFeatures,
      decoration: decoration,
      decorationColor: decorationColor,
      decorationStyle: decorationStyle,
      decorationThickness: decorationThickness,
      fonts: fonts,
    );
  }

  /// Applies the Quando font family from Google Fonts to every
  /// [TextStyle] in the given [textTheme].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Quando
  static TextTheme quandoTextTheme([TextTheme? textTheme]) {
    textTheme ??= ThemeData.light().textTheme;
    return TextTheme(
      displayLarge: quando(textStyle: textTheme.displayLarge),
      displayMedium: quando(textStyle: textTheme.displayMedium),
      displaySmall: quando(textStyle: textTheme.displaySmall),
      headlineLarge: quando(textStyle: textTheme.headlineLarge),
      headlineMedium: quando(textStyle: textTheme.headlineMedium),
      headlineSmall: quando(textStyle: textTheme.headlineSmall),
      titleLarge: quando(textStyle: textTheme.titleLarge),
      titleMedium: quando(textStyle: textTheme.titleMedium),
      titleSmall: quando(textStyle: textTheme.titleSmall),
      bodyLarge: quando(textStyle: textTheme.bodyLarge),
      bodyMedium: quando(textStyle: textTheme.bodyMedium),
      bodySmall: quando(textStyle: textTheme.bodySmall),
      labelLarge: quando(textStyle: textTheme.labelLarge),
      labelMedium: quando(textStyle: textTheme.labelMedium),
      labelSmall: quando(textStyle: textTheme.labelSmall),
    );
  }

  /// Applies the Quantico font family from Google Fonts to the
  /// given [textStyle].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Quantico
  static TextStyle quantico({
    TextStyle? textStyle,
    Color? color,
    Color? backgroundColor,
    double? fontSize,
    FontWeight? fontWeight,
    FontStyle? fontStyle,
    double? letterSpacing,
    double? wordSpacing,
    TextBaseline? textBaseline,
    double? height,
    Locale? locale,
    Paint? foreground,
    Paint? background,
    List<ui.Shadow>? shadows,
    List<ui.FontFeature>? fontFeatures,
    TextDecoration? decoration,
    Color? decorationColor,
    TextDecorationStyle? decorationStyle,
    double? decorationThickness,
  }) {
    final fonts = <GoogleFontsVariant, GoogleFontsFile>{
      const GoogleFontsVariant(
        fontWeight: FontWeight.w400,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        '6f10dca42b42c9253a3a2cca6cdaf1c5ea34d856627c345beda57e1231836fd3',
        18656,
      ),
      const GoogleFontsVariant(
        fontWeight: FontWeight.w400,
        fontStyle: FontStyle.italic,
      ): GoogleFontsFile(
        'e920890272e2f0a6ac37e5ef10dfc1a45ceb58a85cecda1befc17880e4413844',
        19836,
      ),
      const GoogleFontsVariant(
        fontWeight: FontWeight.w700,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        '0e239fedd7cc4e31856903431cd8b34c72bbbb78fe8c62bd44ca46e1d14258ee',
        18616,
      ),
      const GoogleFontsVariant(
        fontWeight: FontWeight.w700,
        fontStyle: FontStyle.italic,
      ): GoogleFontsFile(
        '075721eb9ab1a169a4ce792f040170027a8262dd2f06dbfeb14bab8c7d839cab',
        18364,
      ),
    };

    return googleFontsTextStyle(
      textStyle: textStyle,
      fontFamily: 'Quantico',
      color: color,
      backgroundColor: backgroundColor,
      fontSize: fontSize,
      fontWeight: fontWeight,
      fontStyle: fontStyle,
      letterSpacing: letterSpacing,
      wordSpacing: wordSpacing,
      textBaseline: textBaseline,
      height: height,
      locale: locale,
      foreground: foreground,
      background: background,
      shadows: shadows,
      fontFeatures: fontFeatures,
      decoration: decoration,
      decorationColor: decorationColor,
      decorationStyle: decorationStyle,
      decorationThickness: decorationThickness,
      fonts: fonts,
    );
  }

  /// Applies the Quantico font family from Google Fonts to every
  /// [TextStyle] in the given [textTheme].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Quantico
  static TextTheme quanticoTextTheme([TextTheme? textTheme]) {
    textTheme ??= ThemeData.light().textTheme;
    return TextTheme(
      displayLarge: quantico(textStyle: textTheme.displayLarge),
      displayMedium: quantico(textStyle: textTheme.displayMedium),
      displaySmall: quantico(textStyle: textTheme.displaySmall),
      headlineLarge: quantico(textStyle: textTheme.headlineLarge),
      headlineMedium: quantico(textStyle: textTheme.headlineMedium),
      headlineSmall: quantico(textStyle: textTheme.headlineSmall),
      titleLarge: quantico(textStyle: textTheme.titleLarge),
      titleMedium: quantico(textStyle: textTheme.titleMedium),
      titleSmall: quantico(textStyle: textTheme.titleSmall),
      bodyLarge: quantico(textStyle: textTheme.bodyLarge),
      bodyMedium: quantico(textStyle: textTheme.bodyMedium),
      bodySmall: quantico(textStyle: textTheme.bodySmall),
      labelLarge: quantico(textStyle: textTheme.labelLarge),
      labelMedium: quantico(textStyle: textTheme.labelMedium),
      labelSmall: quantico(textStyle: textTheme.labelSmall),
    );
  }

  /// Applies the Quattrocento font family from Google Fonts to the
  /// given [textStyle].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Quattrocento
  static TextStyle quattrocento({
    TextStyle? textStyle,
    Color? color,
    Color? backgroundColor,
    double? fontSize,
    FontWeight? fontWeight,
    FontStyle? fontStyle,
    double? letterSpacing,
    double? wordSpacing,
    TextBaseline? textBaseline,
    double? height,
    Locale? locale,
    Paint? foreground,
    Paint? background,
    List<ui.Shadow>? shadows,
    List<ui.FontFeature>? fontFeatures,
    TextDecoration? decoration,
    Color? decorationColor,
    TextDecorationStyle? decorationStyle,
    double? decorationThickness,
  }) {
    final fonts = <GoogleFontsVariant, GoogleFontsFile>{
      const GoogleFontsVariant(
        fontWeight: FontWeight.w400,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        'f36a9561fc4986d0aac4878ec4f351a432931773328b293355e3cf1c3655212d',
        65952,
      ),
      const GoogleFontsVariant(
        fontWeight: FontWeight.w700,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        'a8a5308cad793492be58b4f5dac884b7917e7a03227cc63898db9643cc13c2ed',
        66664,
      ),
    };

    return googleFontsTextStyle(
      textStyle: textStyle,
      fontFamily: 'Quattrocento',
      color: color,
      backgroundColor: backgroundColor,
      fontSize: fontSize,
      fontWeight: fontWeight,
      fontStyle: fontStyle,
      letterSpacing: letterSpacing,
      wordSpacing: wordSpacing,
      textBaseline: textBaseline,
      height: height,
      locale: locale,
      foreground: foreground,
      background: background,
      shadows: shadows,
      fontFeatures: fontFeatures,
      decoration: decoration,
      decorationColor: decorationColor,
      decorationStyle: decorationStyle,
      decorationThickness: decorationThickness,
      fonts: fonts,
    );
  }

  /// Applies the Quattrocento font family from Google Fonts to every
  /// [TextStyle] in the given [textTheme].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Quattrocento
  static TextTheme quattrocentoTextTheme([TextTheme? textTheme]) {
    textTheme ??= ThemeData.light().textTheme;
    return TextTheme(
      displayLarge: quattrocento(textStyle: textTheme.displayLarge),
      displayMedium: quattrocento(textStyle: textTheme.displayMedium),
      displaySmall: quattrocento(textStyle: textTheme.displaySmall),
      headlineLarge: quattrocento(textStyle: textTheme.headlineLarge),
      headlineMedium: quattrocento(textStyle: textTheme.headlineMedium),
      headlineSmall: quattrocento(textStyle: textTheme.headlineSmall),
      titleLarge: quattrocento(textStyle: textTheme.titleLarge),
      titleMedium: quattrocento(textStyle: textTheme.titleMedium),
      titleSmall: quattrocento(textStyle: textTheme.titleSmall),
      bodyLarge: quattrocento(textStyle: textTheme.bodyLarge),
      bodyMedium: quattrocento(textStyle: textTheme.bodyMedium),
      bodySmall: quattrocento(textStyle: textTheme.bodySmall),
      labelLarge: quattrocento(textStyle: textTheme.labelLarge),
      labelMedium: quattrocento(textStyle: textTheme.labelMedium),
      labelSmall: quattrocento(textStyle: textTheme.labelSmall),
    );
  }

  /// Applies the Quattrocento Sans font family from Google Fonts to the
  /// given [textStyle].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Quattrocento+Sans
  static TextStyle quattrocentoSans({
    TextStyle? textStyle,
    Color? color,
    Color? backgroundColor,
    double? fontSize,
    FontWeight? fontWeight,
    FontStyle? fontStyle,
    double? letterSpacing,
    double? wordSpacing,
    TextBaseline? textBaseline,
    double? height,
    Locale? locale,
    Paint? foreground,
    Paint? background,
    List<ui.Shadow>? shadows,
    List<ui.FontFeature>? fontFeatures,
    TextDecoration? decoration,
    Color? decorationColor,
    TextDecorationStyle? decorationStyle,
    double? decorationThickness,
  }) {
    final fonts = <GoogleFontsVariant, GoogleFontsFile>{
      const GoogleFontsVariant(
        fontWeight: FontWeight.w400,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        '7bb731cc60b46f91bb52998bec01f9cdb4024f7f5d95311c17bffeee0062024a',
        38944,
      ),
      const GoogleFontsVariant(
        fontWeight: FontWeight.w400,
        fontStyle: FontStyle.italic,
      ): GoogleFontsFile(
        '2dbd5b51296f7b89cabf7e1450033af585ca2aa009d50d2ffe1091472e685579',
        44116,
      ),
      const GoogleFontsVariant(
        fontWeight: FontWeight.w700,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        '65e121fdbdf2cde8fbebe307381dcfdf129c1fd68c5cd08b6b36c5e83062d6cf',
        38464,
      ),
      const GoogleFontsVariant(
        fontWeight: FontWeight.w700,
        fontStyle: FontStyle.italic,
      ): GoogleFontsFile(
        '5873ed8a6a0482a27a63f010cdb0fc742c8f51debc2d7f2055141d4789440a2d',
        39552,
      ),
    };

    return googleFontsTextStyle(
      textStyle: textStyle,
      fontFamily: 'QuattrocentoSans',
      color: color,
      backgroundColor: backgroundColor,
      fontSize: fontSize,
      fontWeight: fontWeight,
      fontStyle: fontStyle,
      letterSpacing: letterSpacing,
      wordSpacing: wordSpacing,
      textBaseline: textBaseline,
      height: height,
      locale: locale,
      foreground: foreground,
      background: background,
      shadows: shadows,
      fontFeatures: fontFeatures,
      decoration: decoration,
      decorationColor: decorationColor,
      decorationStyle: decorationStyle,
      decorationThickness: decorationThickness,
      fonts: fonts,
    );
  }

  /// Applies the Quattrocento Sans font family from Google Fonts to every
  /// [TextStyle] in the given [textTheme].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Quattrocento+Sans
  static TextTheme quattrocentoSansTextTheme([TextTheme? textTheme]) {
    textTheme ??= ThemeData.light().textTheme;
    return TextTheme(
      displayLarge: quattrocentoSans(textStyle: textTheme.displayLarge),
      displayMedium: quattrocentoSans(textStyle: textTheme.displayMedium),
      displaySmall: quattrocentoSans(textStyle: textTheme.displaySmall),
      headlineLarge: quattrocentoSans(textStyle: textTheme.headlineLarge),
      headlineMedium: quattrocentoSans(textStyle: textTheme.headlineMedium),
      headlineSmall: quattrocentoSans(textStyle: textTheme.headlineSmall),
      titleLarge: quattrocentoSans(textStyle: textTheme.titleLarge),
      titleMedium: quattrocentoSans(textStyle: textTheme.titleMedium),
      titleSmall: quattrocentoSans(textStyle: textTheme.titleSmall),
      bodyLarge: quattrocentoSans(textStyle: textTheme.bodyLarge),
      bodyMedium: quattrocentoSans(textStyle: textTheme.bodyMedium),
      bodySmall: quattrocentoSans(textStyle: textTheme.bodySmall),
      labelLarge: quattrocentoSans(textStyle: textTheme.labelLarge),
      labelMedium: quattrocentoSans(textStyle: textTheme.labelMedium),
      labelSmall: quattrocentoSans(textStyle: textTheme.labelSmall),
    );
  }

  /// Applies the Questrial font family from Google Fonts to the
  /// given [textStyle].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Questrial
  static TextStyle questrial({
    TextStyle? textStyle,
    Color? color,
    Color? backgroundColor,
    double? fontSize,
    FontWeight? fontWeight,
    FontStyle? fontStyle,
    double? letterSpacing,
    double? wordSpacing,
    TextBaseline? textBaseline,
    double? height,
    Locale? locale,
    Paint? foreground,
    Paint? background,
    List<ui.Shadow>? shadows,
    List<ui.FontFeature>? fontFeatures,
    TextDecoration? decoration,
    Color? decorationColor,
    TextDecorationStyle? decorationStyle,
    double? decorationThickness,
  }) {
    final fonts = <GoogleFontsVariant, GoogleFontsFile>{
      const GoogleFontsVariant(
        fontWeight: FontWeight.w400,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        'a03a863ae8309aa6530c0d8df4e28b31603d236ae11b23b87af29c097e43963b',
        115384,
      ),
    };

    return googleFontsTextStyle(
      textStyle: textStyle,
      fontFamily: 'Questrial',
      color: color,
      backgroundColor: backgroundColor,
      fontSize: fontSize,
      fontWeight: fontWeight,
      fontStyle: fontStyle,
      letterSpacing: letterSpacing,
      wordSpacing: wordSpacing,
      textBaseline: textBaseline,
      height: height,
      locale: locale,
      foreground: foreground,
      background: background,
      shadows: shadows,
      fontFeatures: fontFeatures,
      decoration: decoration,
      decorationColor: decorationColor,
      decorationStyle: decorationStyle,
      decorationThickness: decorationThickness,
      fonts: fonts,
    );
  }

  /// Applies the Questrial font family from Google Fonts to every
  /// [TextStyle] in the given [textTheme].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Questrial
  static TextTheme questrialTextTheme([TextTheme? textTheme]) {
    textTheme ??= ThemeData.light().textTheme;
    return TextTheme(
      displayLarge: questrial(textStyle: textTheme.displayLarge),
      displayMedium: questrial(textStyle: textTheme.displayMedium),
      displaySmall: questrial(textStyle: textTheme.displaySmall),
      headlineLarge: questrial(textStyle: textTheme.headlineLarge),
      headlineMedium: questrial(textStyle: textTheme.headlineMedium),
      headlineSmall: questrial(textStyle: textTheme.headlineSmall),
      titleLarge: questrial(textStyle: textTheme.titleLarge),
      titleMedium: questrial(textStyle: textTheme.titleMedium),
      titleSmall: questrial(textStyle: textTheme.titleSmall),
      bodyLarge: questrial(textStyle: textTheme.bodyLarge),
      bodyMedium: questrial(textStyle: textTheme.bodyMedium),
      bodySmall: questrial(textStyle: textTheme.bodySmall),
      labelLarge: questrial(textStyle: textTheme.labelLarge),
      labelMedium: questrial(textStyle: textTheme.labelMedium),
      labelSmall: questrial(textStyle: textTheme.labelSmall),
    );
  }

  /// Applies the Quicksand font family from Google Fonts to the
  /// given [textStyle].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Quicksand
  static TextStyle quicksand({
    TextStyle? textStyle,
    Color? color,
    Color? backgroundColor,
    double? fontSize,
    FontWeight? fontWeight,
    FontStyle? fontStyle,
    double? letterSpacing,
    double? wordSpacing,
    TextBaseline? textBaseline,
    double? height,
    Locale? locale,
    Paint? foreground,
    Paint? background,
    List<ui.Shadow>? shadows,
    List<ui.FontFeature>? fontFeatures,
    TextDecoration? decoration,
    Color? decorationColor,
    TextDecorationStyle? decorationStyle,
    double? decorationThickness,
  }) {
    final fonts = <GoogleFontsVariant, GoogleFontsFile>{
      const GoogleFontsVariant(
        fontWeight: FontWeight.w300,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        'd17360111663672d1b0533ecc2eee58823f6265adf0285c4c0427e8a1b225853',
        72940,
      ),
      const GoogleFontsVariant(
        fontWeight: FontWeight.w400,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        'd48e181f1998252c3a7fb7a0b202a93cd15590ebc636c58dc17f5cc6000ac314',
        73200,
      ),
      const GoogleFontsVariant(
        fontWeight: FontWeight.w500,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        '4770e82259aea519d83a539f71ba4c29fca2994295249694fd929ac60f10a97b',
        73208,
      ),
      const GoogleFontsVariant(
        fontWeight: FontWeight.w600,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        '0984d7438bf851acb6f55fa02c860414907543dfe2a9229f9c24e1c6e25f8fea',
        73116,
      ),
      const GoogleFontsVariant(
        fontWeight: FontWeight.w700,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        '1a693fb78c1624ba780e833d6e40a6f2cd6355b39e30011e63bcd00c70fda8e8',
        72892,
      ),
    };

    return googleFontsTextStyle(
      textStyle: textStyle,
      fontFamily: 'Quicksand',
      color: color,
      backgroundColor: backgroundColor,
      fontSize: fontSize,
      fontWeight: fontWeight,
      fontStyle: fontStyle,
      letterSpacing: letterSpacing,
      wordSpacing: wordSpacing,
      textBaseline: textBaseline,
      height: height,
      locale: locale,
      foreground: foreground,
      background: background,
      shadows: shadows,
      fontFeatures: fontFeatures,
      decoration: decoration,
      decorationColor: decorationColor,
      decorationStyle: decorationStyle,
      decorationThickness: decorationThickness,
      fonts: fonts,
    );
  }

  /// Applies the Quicksand font family from Google Fonts to every
  /// [TextStyle] in the given [textTheme].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Quicksand
  static TextTheme quicksandTextTheme([TextTheme? textTheme]) {
    textTheme ??= ThemeData.light().textTheme;
    return TextTheme(
      displayLarge: quicksand(textStyle: textTheme.displayLarge),
      displayMedium: quicksand(textStyle: textTheme.displayMedium),
      displaySmall: quicksand(textStyle: textTheme.displaySmall),
      headlineLarge: quicksand(textStyle: textTheme.headlineLarge),
      headlineMedium: quicksand(textStyle: textTheme.headlineMedium),
      headlineSmall: quicksand(textStyle: textTheme.headlineSmall),
      titleLarge: quicksand(textStyle: textTheme.titleLarge),
      titleMedium: quicksand(textStyle: textTheme.titleMedium),
      titleSmall: quicksand(textStyle: textTheme.titleSmall),
      bodyLarge: quicksand(textStyle: textTheme.bodyLarge),
      bodyMedium: quicksand(textStyle: textTheme.bodyMedium),
      bodySmall: quicksand(textStyle: textTheme.bodySmall),
      labelLarge: quicksand(textStyle: textTheme.labelLarge),
      labelMedium: quicksand(textStyle: textTheme.labelMedium),
      labelSmall: quicksand(textStyle: textTheme.labelSmall),
    );
  }

  /// Applies the Quintessential font family from Google Fonts to the
  /// given [textStyle].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Quintessential
  static TextStyle quintessential({
    TextStyle? textStyle,
    Color? color,
    Color? backgroundColor,
    double? fontSize,
    FontWeight? fontWeight,
    FontStyle? fontStyle,
    double? letterSpacing,
    double? wordSpacing,
    TextBaseline? textBaseline,
    double? height,
    Locale? locale,
    Paint? foreground,
    Paint? background,
    List<ui.Shadow>? shadows,
    List<ui.FontFeature>? fontFeatures,
    TextDecoration? decoration,
    Color? decorationColor,
    TextDecorationStyle? decorationStyle,
    double? decorationThickness,
  }) {
    final fonts = <GoogleFontsVariant, GoogleFontsFile>{
      const GoogleFontsVariant(
        fontWeight: FontWeight.w400,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        'b95696fa4eb6139993f920cc18b7ec1048c6ec04713eb886d21008514bdf0c52',
        70712,
      ),
    };

    return googleFontsTextStyle(
      textStyle: textStyle,
      fontFamily: 'Quintessential',
      color: color,
      backgroundColor: backgroundColor,
      fontSize: fontSize,
      fontWeight: fontWeight,
      fontStyle: fontStyle,
      letterSpacing: letterSpacing,
      wordSpacing: wordSpacing,
      textBaseline: textBaseline,
      height: height,
      locale: locale,
      foreground: foreground,
      background: background,
      shadows: shadows,
      fontFeatures: fontFeatures,
      decoration: decoration,
      decorationColor: decorationColor,
      decorationStyle: decorationStyle,
      decorationThickness: decorationThickness,
      fonts: fonts,
    );
  }

  /// Applies the Quintessential font family from Google Fonts to every
  /// [TextStyle] in the given [textTheme].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Quintessential
  static TextTheme quintessentialTextTheme([TextTheme? textTheme]) {
    textTheme ??= ThemeData.light().textTheme;
    return TextTheme(
      displayLarge: quintessential(textStyle: textTheme.displayLarge),
      displayMedium: quintessential(textStyle: textTheme.displayMedium),
      displaySmall: quintessential(textStyle: textTheme.displaySmall),
      headlineLarge: quintessential(textStyle: textTheme.headlineLarge),
      headlineMedium: quintessential(textStyle: textTheme.headlineMedium),
      headlineSmall: quintessential(textStyle: textTheme.headlineSmall),
      titleLarge: quintessential(textStyle: textTheme.titleLarge),
      titleMedium: quintessential(textStyle: textTheme.titleMedium),
      titleSmall: quintessential(textStyle: textTheme.titleSmall),
      bodyLarge: quintessential(textStyle: textTheme.bodyLarge),
      bodyMedium: quintessential(textStyle: textTheme.bodyMedium),
      bodySmall: quintessential(textStyle: textTheme.bodySmall),
      labelLarge: quintessential(textStyle: textTheme.labelLarge),
      labelMedium: quintessential(textStyle: textTheme.labelMedium),
      labelSmall: quintessential(textStyle: textTheme.labelSmall),
    );
  }

  /// Applies the Qwigley font family from Google Fonts to the
  /// given [textStyle].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Qwigley
  static TextStyle qwigley({
    TextStyle? textStyle,
    Color? color,
    Color? backgroundColor,
    double? fontSize,
    FontWeight? fontWeight,
    FontStyle? fontStyle,
    double? letterSpacing,
    double? wordSpacing,
    TextBaseline? textBaseline,
    double? height,
    Locale? locale,
    Paint? foreground,
    Paint? background,
    List<ui.Shadow>? shadows,
    List<ui.FontFeature>? fontFeatures,
    TextDecoration? decoration,
    Color? decorationColor,
    TextDecorationStyle? decorationStyle,
    double? decorationThickness,
  }) {
    final fonts = <GoogleFontsVariant, GoogleFontsFile>{
      const GoogleFontsVariant(
        fontWeight: FontWeight.w400,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        '3d61de417ccd8ab1ac0602fad3a761fd007c801e4ab1d4f3e0741a4b1dc40ca0',
        56936,
      ),
    };

    return googleFontsTextStyle(
      textStyle: textStyle,
      fontFamily: 'Qwigley',
      color: color,
      backgroundColor: backgroundColor,
      fontSize: fontSize,
      fontWeight: fontWeight,
      fontStyle: fontStyle,
      letterSpacing: letterSpacing,
      wordSpacing: wordSpacing,
      textBaseline: textBaseline,
      height: height,
      locale: locale,
      foreground: foreground,
      background: background,
      shadows: shadows,
      fontFeatures: fontFeatures,
      decoration: decoration,
      decorationColor: decorationColor,
      decorationStyle: decorationStyle,
      decorationThickness: decorationThickness,
      fonts: fonts,
    );
  }

  /// Applies the Qwigley font family from Google Fonts to every
  /// [TextStyle] in the given [textTheme].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Qwigley
  static TextTheme qwigleyTextTheme([TextTheme? textTheme]) {
    textTheme ??= ThemeData.light().textTheme;
    return TextTheme(
      displayLarge: qwigley(textStyle: textTheme.displayLarge),
      displayMedium: qwigley(textStyle: textTheme.displayMedium),
      displaySmall: qwigley(textStyle: textTheme.displaySmall),
      headlineLarge: qwigley(textStyle: textTheme.headlineLarge),
      headlineMedium: qwigley(textStyle: textTheme.headlineMedium),
      headlineSmall: qwigley(textStyle: textTheme.headlineSmall),
      titleLarge: qwigley(textStyle: textTheme.titleLarge),
      titleMedium: qwigley(textStyle: textTheme.titleMedium),
      titleSmall: qwigley(textStyle: textTheme.titleSmall),
      bodyLarge: qwigley(textStyle: textTheme.bodyLarge),
      bodyMedium: qwigley(textStyle: textTheme.bodyMedium),
      bodySmall: qwigley(textStyle: textTheme.bodySmall),
      labelLarge: qwigley(textStyle: textTheme.labelLarge),
      labelMedium: qwigley(textStyle: textTheme.labelMedium),
      labelSmall: qwigley(textStyle: textTheme.labelSmall),
    );
  }

  /// Applies the Qwitcher Grypen font family from Google Fonts to the
  /// given [textStyle].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Qwitcher+Grypen
  static TextStyle qwitcherGrypen({
    TextStyle? textStyle,
    Color? color,
    Color? backgroundColor,
    double? fontSize,
    FontWeight? fontWeight,
    FontStyle? fontStyle,
    double? letterSpacing,
    double? wordSpacing,
    TextBaseline? textBaseline,
    double? height,
    Locale? locale,
    Paint? foreground,
    Paint? background,
    List<ui.Shadow>? shadows,
    List<ui.FontFeature>? fontFeatures,
    TextDecoration? decoration,
    Color? decorationColor,
    TextDecorationStyle? decorationStyle,
    double? decorationThickness,
  }) {
    final fonts = <GoogleFontsVariant, GoogleFontsFile>{
      const GoogleFontsVariant(
        fontWeight: FontWeight.w400,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        'bc16c78b26f72cd4470b066075303c178d9df7c772d18aa46ed7c24df8479c79',
        137364,
      ),
      const GoogleFontsVariant(
        fontWeight: FontWeight.w700,
        fontStyle: FontStyle.normal,
      ): GoogleFontsFile(
        '21c2ea64c0ca3797d69890144907ab0a8cb005a6ecf3448b1a59a3182d72787a',
        142980,
      ),
    };

    return googleFontsTextStyle(
      textStyle: textStyle,
      fontFamily: 'QwitcherGrypen',
      color: color,
      backgroundColor: backgroundColor,
      fontSize: fontSize,
      fontWeight: fontWeight,
      fontStyle: fontStyle,
      letterSpacing: letterSpacing,
      wordSpacing: wordSpacing,
      textBaseline: textBaseline,
      height: height,
      locale: locale,
      foreground: foreground,
      background: background,
      shadows: shadows,
      fontFeatures: fontFeatures,
      decoration: decoration,
      decorationColor: decorationColor,
      decorationStyle: decorationStyle,
      decorationThickness: decorationThickness,
      fonts: fonts,
    );
  }

  /// Applies the Qwitcher Grypen font family from Google Fonts to every
  /// [TextStyle] in the given [textTheme].
  ///
  /// See:
  ///  * https://fonts.google.com/specimen/Qwitcher+Grypen
  static TextTheme qwitcherGrypenTextTheme([TextTheme? textTheme]) {
    textTheme ??= ThemeData.light().textTheme;
    return TextTheme(
      displayLarge: qwitcherGrypen(textStyle: textTheme.displayLarge),
      displayMedium: qwitcherGrypen(textStyle: textTheme.displayMedium),
      displaySmall: qwitcherGrypen(textStyle: textTheme.displaySmall),
      headlineLarge: qwitcherGrypen(textStyle: textTheme.headlineLarge),
      headlineMedium: qwitcherGrypen(textStyle: textTheme.headlineMedium),
      headlineSmall: qwitcherGrypen(textStyle: textTheme.headlineSmall),
      titleLarge: qwitcherGrypen(textStyle: textTheme.titleLarge),
      titleMedium: qwitcherGrypen(textStyle: textTheme.titleMedium),
      titleSmall: qwitcherGrypen(textStyle: textTheme.titleSmall),
      bodyLarge: qwitcherGrypen(textStyle: textTheme.bodyLarge),
      bodyMedium: qwitcherGrypen(textStyle: textTheme.bodyMedium),
      bodySmall: qwitcherGrypen(textStyle: textTheme.bodySmall),
      labelLarge: qwitcherGrypen(textStyle: textTheme.labelLarge),
      labelMedium: qwitcherGrypen(textStyle: textTheme.labelMedium),
      labelSmall: qwitcherGrypen(textStyle: textTheme.labelSmall),
    );
  }
}
